/*
  CPP_CONTEST=2018Junio
  CPP_PROBLEM=F
  CPP_LANG=CPP+OPENMP
  CPP_PROCESSES_PER_NODE=calisto 1
*/

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>

extern void escribir(int *,int,int);

void copiar(int n,int *vd,int *vo) 
//se copia el vector vo en el vd
{
  int i;
  for(i=0;i<n;i++)
    vd[i]=vo[i];
}

int back(int n,int *A,int fila,int columna)
{
  int valor;
  if(fila==n-1)
    return A[fila*n+columna];
  else
  {
    int maximo=0;
    if(columna!=0)
    {
      valor=A[fila*n+columna]+back(n,A,fila+1,columna-1);
      if(valor>maximo)
        maximo=valor;
    }
    if(columna!=n-1)
    {
      valor=A[fila*n+columna]+back(n,A,fila+1,columna+1);
      if(valor>maximo)
        maximo=valor;
    }
    valor=A[fila*n+columna]+back(n,A,fila+1,columna);
    if(valor>maximo)
      maximo=valor;
    return maximo;
  }
}

int  sec(int n,int *A)
{
  int VOA=0; //valor óptimo actual
  
  for(int i=0;i<n;i++) //se calculan los óptimos empezando en cada una de las columnas de la primera fila
  {
     int valor=0; //para almacenar el valor calculado
     valor=back(n,A,0,i); //se pasa la fila y columna por lo que se sigue haciendo el backtracking
     if(valor>VOA)
     {
        VOA=valor;
     }
#ifdef DEBUG
  printf("columna %d , valor %d , optimo %d\n",i,valor,VOA);
#endif
  }
  return VOA;
}

